/*
Copyright (C) (2020) (Mathieu Bergeron) (mathieu.bergeron@cmontmorency.qc.ca)

This file is part of Ntro, an application framework designed with teaching in mind.

This is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
package ca.ntro.ntro_core_impl.services;

import ca.ntro.core.NtroCore;
import ca.ntro.core.services.ExceptionService;
import ca.ntro.ntro_core_impl.exceptions.Break;

public class ExceptionServiceDefault implements ExceptionService {
	
	private boolean catchingMode = false;
	private Throwable exception = null;

	@Override
	public void throwException(Throwable t) {
		if(catchingMode) {

			exception = t;

		}else if(!(t instanceof Break)){

			NtroCore.logger().fatal(t);

		}
	}

	@Override
	public void enterCatchingMode() {
		exception = null;
		catchingMode = true;
	}

	@Override
	public void exitCatchingMode() {
		catchingMode = false;
	}

	@Override
	public boolean hasException() {
		return exception != null;
	}

	@Override
	public Throwable exception() {
		return exception;
	}
}
