package pong.commun.modeles;

import java.util.ArrayList;
import java.util.List;

import ca.ntro.app.models.Model;
import ca.ntro.app.models.WatchJson;
import ca.ntro.app.models.WriteObjectGraph;
import pong.commun.valeurs.RendezVous;
import pong.commun.valeurs.Joueur;
import pong.frontal.vues.VueFileAttente;

public class ModeleFileAttente implements Model, WatchJson, WriteObjectGraph {

	private long prochainIdRendezVous = 1;

	private List<RendezVous> rendezVousDansOrdre = new ArrayList<>();

	public ModeleFileAttente() {
	}
	
	public String ajouterRendezVous(Joueur premierJoueur) {
		String idRendezVous = genererIdRendezVous();
		RendezVous rendezVous = new RendezVous(idRendezVous, premierJoueur);

		rendezVousDansOrdre.add(rendezVous);
		
		return idRendezVous;
	}

	private String genererIdRendezVous() {
		String idRendezVous = String.valueOf(prochainIdRendezVous);
		prochainIdRendezVous++;

		return idRendezVous;
	}
	
	public void afficherSur(VueFileAttente vueFileAttente) {
		vueFileAttente.afficherRendezVousEnTexte(this.toString());
	}
	
	public String toString() {

		StringBuilder builder = new StringBuilder();
		int numeroRendezVous = 1;
		
		for(RendezVous rendezVous : rendezVousDansOrdre) {

			builder.append(numeroRendezVous);
			builder.append(". ");
			builder.append(rendezVous.toString());
			builder.append("\n");

			numeroRendezVous++;
		}

		return builder.toString();
	}
}
