package pong.frontal;


import ca.ntro.app.Ntro;
import ca.ntro.app.session.Session;
import pong.commun.messages.MsgAjouterRendezVous;
import pong.frontal.evenements.EvtAfficherFileAttente;
import pong.frontal.evenements.EvtAfficherPartie;
import pong.frontal.vues.VueFileAttente;
import pong.frontal.vues.VuePartie;
import pong.maquettes.MaquetteJoueurs;

public class SessionPong extends Session<SessionPong> {
	
	private Class<?> vueCourante = VueFileAttente.class;
	
	public SessionPong() {
		super();
	}

	public SessionPong memoriserVueCourante(Class<?> vueCourante) {

		this.vueCourante = vueCourante;

		return this;
	}
	
	public void envoyerEvtPourAfficherVueCourante() {

	  if(vueCourante.equals(VuePartie.class)) {
		  
		  Ntro.newEvent(EvtAfficherPartie.class)
			  .trigger();

	  }else {

		  Ntro.newEvent(EvtAfficherFileAttente.class)
			  .trigger();

	  }

	}

	public void envoyerMsgAjouterRendezVous() {
		Ntro.newMessage(MsgAjouterRendezVous.class)
		    .setPremierJoueur(MaquetteJoueurs.joueurAleatoire(this.sessionId()))
		    .send();
	}

}
